---
title: Cross-browser audio basics
slug: Web/Guide/Audio_and_video_delivery/Cross-browser_audio_basics
tags:
  - Apps
  - Audio
  - Guide
  - HTML5
  - Media
  - events
---
<div class="seoSummary">
<p>This article provides:</p>

<ul>
 <li>a basic guide to creating a cross-browser HTML5 audio player with all the associated attributes, properties, and events explained</li>
 <li>a guide to custom controls created using the Media API</li>
</ul>
</div>

<h2 id="Basic_Audio_example">Basic Audio example</h2>

<p>The code below is an example of a basic audio implementation using HTML5:</p>

<pre class="brush: html notranslate">&lt;audio controls&gt;
  &lt;source src="audiofile.mp3" type="audio/mpeg"&gt;
  &lt;source src="audiofile.ogg" type="audio/ogg"&gt;
  &lt;!-- fallback for non supporting browsers goes here --&gt;
  &lt;p&gt;Your browser does not support HTML5 audio, but you can still
     &lt;a href="audiofile.mp3"&gt;download the music&lt;/a&gt;.&lt;/p&gt;
&lt;/audio&gt;</pre>

<div class="note">
<p><strong>Note</strong>: You can also use an MP4 file instead of MP3. MP4 files typically contain <a href="http://en.wikipedia.org/wiki/Advanced_Audio_Coding">AAC</a> encoded audio. You can use <code>type="audio/mp4"</code>. (Currently, browsers that support mp3 also support mp4 audio).</p>
</div>

<ul>
 <li>Here we define an {{ htmlelement("audio") }} element with multiple sources — we do this as not all browsers support the same audio formats. To ensure reasonable coverage, we should specify at least two different formats. The two formats that will give maximum coverage are mp3 and ogg vorbis.</li>
 <li>We do this using the {{ htmlelement("source") }} element, which takes the attributes <code>src</code> and <code>type</code>.
  <ul>
   <li><code>src</code> contains the path to the audio file to be loaded (relative or absolute).</li>
   <li><code>type</code> is used to inform the browser of the file type. If omitted, most browsers will attempt to guess this from the file extension.<span id="cke_bm_369E" style="display: none;"> </span></li>
  </ul>
 </li>
 <li>If the {{ htmlelement("audio") }} element is not supported then {{ htmlelement("audio") }} and {{ htmlelement("source") }} will be ignored. However any supported text or elements that you define within {{ htmlelement("audio") }} will be displayed or acted upon. So the ideal place to create a fallback or inform of incompatibility is before the closing <code>&lt;/audio&gt;</code> tag. In this case, we've provided a simple paragraph including a link to download the audio directly.</li>
 <li>The <code>controls</code> attribute on the {{ htmlelement("audio") }} element is specified when we require the browser to provide us with default playback controls. If you don't specify this attribute, no controls will appear — and you will instead have to create your own controls and program their functionality using the Media API (see below). However, that can be a good approach, because the default controls look different among various browsers. So creating your own controls ensures a consistent look for the controls across all browsers.</li>
</ul>

<h2 id="HTML5_audio_in_detail">HTML5 audio in detail</h2>

<p>Now we've looked at a basic example, let's now explore the different aspects of HTML5 audio in more detail.</p>

<h3 id="Audio_HTML_attributes">Audio HTML attributes</h3>

<p>We can specify a number of attributes with the audio tag to further determine the way audio is initialized.</p>

<h4 id="autoplay">autoplay</h4>

<p>Specifying <code>autoplay</code> will cause the audio to start playing as soon as possible and without any user interaction — in short, the audio will autoplay.</p>

<pre class="brush: html notranslate">&lt;audio autoplay&gt;
  ...
&lt;/audio&gt;</pre>

<div class="note">
<p><strong>Note</strong>: This value is often ignored on mobile platforms, and its use is not recommended unless really necessary. Auto-playing audio (and video) is usually really annoying. Plus browsers have policies that will block autoplay entirely in many situations. See the <a href="/en-US/docs/Web/Media/Autoplay_guide">Autoplay guide for media and Web Audio APIs</a> for details.</p>
</div>

<h4 id="loop">loop</h4>

<p>The <code>loop</code> attribute will ensure that upon getting to the end of the audio clip, the audio clip will loop back to the beginning and start playing again.</p>

<pre class="brush: html notranslate">&lt;audio loop&gt;
  ...
&lt;/audio&gt;</pre>

<h4 id="muted">muted</h4>

<p>If you want the audio to start muted (no volume), add the <code>muted</code> attribute.</p>

<pre class="brush: html notranslate">&lt;audio muted&gt;
  ...
&lt;/audio&gt;</pre>

<div class="note">
<p><strong>Note</strong>: This value is often ignored on mobile platforms.</p>
</div>

<h4 id="preload">preload</h4>

<p>The <code>preload</code> attribute allows you to specify a preference for how the browser preloads the audio, in other words, which part of the file it downloads when the {{ htmlelement("audio") }} element is initialized, and before the play button is pressed.</p>

<p><code>preload</code> can take 3 different values:</p>

<ol>
 <li><code>none</code>: Don't download anything before the play button is pressed.</li>
 <li><code>metadata</code>: Download the audio metadata; this is usually the best option, as it allows you to access and display information such as audio length, and allow the browser to work out which audio file it should use.</li>
 <li><code>auto</code>: Download the whole audio file as soon as possible. This is generally not a good option unless you can guarantee your users will have a fast network connection.</li>
</ol>

<div class="note">
<p><strong>Note</strong>: This value is often ignored on mobile platforms.</p>
</div>

<pre class="brush: html notranslate">&lt;audio preload="auto"&gt;
  ...
&lt;/audio&gt;</pre>

<h4 id="controls">controls</h4>

<p>We specify the <code>controls</code> attribute when we require the browser to provide us with its default playback controls.</p>

<pre class="brush: html notranslate">&lt;audio controls&gt;
  ...
&lt;/audio&gt;</pre>

<h4 id="src">src</h4>

<p>As mentioned above, you can use the {{ htmlelement("source") }} element to specify one or more source audio files. Alternatively, you can include the <code>src</code> attribute directly on the {{ htmlelement("audio") }} element to specify a single source file.</p>

<pre class="brush: html notranslate">&lt;audio src="audiofile.mp3"&gt;
  ...
&lt;/audio&gt;</pre>

<h4 id="type">type</h4>

<p>As mentioned above, to be sure that the browser knows what type of file is being specified, it's good practice to specify a <code>type</code> attribute alongside the <code>src</code> attribute. The <code>type</code> attribute specifies the MIME type or Internet Media Type of the file.</p>

<pre class="brush: html notranslate">&lt;audio src="audiofile.mp3" type="audio/mpeg"&gt;
  ...
&lt;/audio&gt;</pre>

<h3 id="Manipulating_the_Audio_Element_with_JavaScript">Manipulating the Audio Element with JavaScript</h3>

<p>In addition to being able to specify various attributes in HTML, the {{ htmlelement("audio") }} element comes complete with several properties and methods that you can manipulate via JavaScript.<br>
 <br>
 Given the following HTML:</p>

<pre class="brush: html notranslate">&lt;audio id="my-audio" src="audiofile.mp3"&gt;
  ...
&lt;/audio&gt;</pre>

<p>You can grab the {{htmlelement("audio") }} element like this:</p>

<pre class="brush: js notranslate">var myAudio = document.getElementById('my-audio');</pre>

<p>Alternatively, you can create a new element. Here's an example of creating an {{ htmlelement("audio") }} element, setting the media to play, playing and pausing, and then playing from 5 seconds into the audio:</p>

<pre class="brush: js notranslate">var myAudio = document.createElement('audio');

if (myAudio.canPlayType('audio/mpeg')) {
  myAudio.setAttribute('src','audiofile.mp3');
}

if (myAudio.canPlayType('audio/ogg')) {
  myAudio.setAttribute('src','audiofile.ogg');
}

alert('play');

myAudio.play();

alert('stop');

myAudio.pause();

alert('play from 5 seconds in');

myAudio.currentTime = 5;
myAudio.play();</pre>

<p>Let's explore the available properties and methods in more detail.</p>

<h4 id="play">play</h4>

<p>The <code>play()</code> method is used to tell the audio to play. It takes no parameters.</p>

<pre class="brush: js notranslate">myAudio.play();</pre>

<h4 id="pause">pause</h4>

<p>The <code>pause()</code> method is used to tell the audio to pause. It takes no parameters.</p>

<pre class="brush: js notranslate">myAudio.pause();</pre>

<div class="note">
<p><strong>Note</strong>: There is no stop method — to implement a stop function, you'd have to pause the media then set the <code>{{ anch("currentTime") }}</code> property value to 0.</p>
</div>

<h4 id="canPlayType">canPlayType</h4>

<p>The <code>canPlayType()</code> method asks the browser whether a certain audio file type is supported. It takes the mime type of the type to check as a parameter.</p>

<pre class="brush: js notranslate">if (myAudio.canPlayType('audio/mpeg')) {
  // It's supported.
  // Do something here!
}</pre>

<p><code>canPlayType()</code> returns one of three values:</p>

<ol>
 <li><code>probably</code></li>
 <li><code>maybe</code></li>
 <li>"" (an empty string)</li>
</ol>

<p>In practice, we usually check if the result is true or false. Non-empty strings are true.</p>

<div class="note">
<p><strong>Note</strong>: A very early spec specified that the browser should return <code>no</code> instead of an empty string, but thankfully the number of people using older browsers that implement this version of the spec are few and far between.</p>
</div>

<h4 id="currentTime">currentTime</h4>

<p>The <code>currentTime</code> property gets or sets the current time the audio should play at. This is useful in many ways, for example since <code>play()</code> does not take a parameter we need to set the point to play from separately if we don't want it to be 0.</p>

<p>The value of <code>currentTime</code> is a number which represents the time in seconds.</p>

<pre class="brush: js notranslate">if (myAudio.currentTime &gt; 5) {
  myAudio.currentTime = 3;
}</pre>

<h4 id="volume">volume</h4>

<p>The <code>volume</code> property allows us to set the audio volume, as a number between 0 and 1.</p>

<pre class="brush: js notranslate">// set the volume at 50%
myAudio.volume = 0.5;</pre>

<h2 id="Creating_your_own_custom_audio_player">Creating your own custom audio player</h2>

<p>The JavaScript media API allows you to create your own custom player. Let's take a look at a very minimal example. We can combine HTML and JavaScript to create a very simple player with a play and a pause button. First, we'll set up the audio in the HTML, without the <code>controls</code> attribute, since we are creating our own controls:</p>

<pre class="brush: html notranslate">&lt;audio id="my-audio"&gt;
  &lt;source src="audiofile.mp3" type="audio/mpeg"&gt;
  &lt;source src="audiofile.ogg" type="audio/ogg"&gt;
  &lt;!-- place fallback here as &lt;audio&gt; supporting browsers will ignore it --&gt;
  &lt;p&gt;Download&lt;a href="audiofile.mp3"&gt;audiofile.mp3&lt;/a&gt;&lt;/p&gt;
&lt;/audio&gt;

&lt;!-- custom play and pause buttons --&gt;
&lt;button id="play"&gt;play&lt;/button&gt;
&lt;button id="pause"&gt;pause&lt;/button&gt;</pre>

<p>Next, we attach some functionality to the player using JavaScript:</p>

<pre class="brush: js notranslate">window.onload = function(){

  var myAudio = document.getElementById('my-audio');
  var play = document.getElementById('play');
  var pause = document.getElementById('pause');

  // associate functions with the 'onclick' events
  play.onclick = playAudio;
  pause.onclick = pauseAudio;

  function playAudio() {
    myAudio.play();
  }

  function pauseAudio() {
    myAudio.pause();
  }

}</pre>

<h2 id="Media_loading_events">Media loading events</h2>

<p>Above we have shown how you can create a very simple audio player, but what if we want to show progress, buffering and only activate the buttons when the media is ready to play? Fortunately, there are a number of events we can use to let our player know exactly what is happening.</p>

<p>First, let's take a look at the media loading process in order:</p>

<h3 id="loadstart">loadstart</h3>

<p>The <code>loadstart</code> event tells us that load process has started and the browser is connecting to the media.</p>

<pre class="brush: js notranslate">myAudio.addEventListener("loadstart", function() {
  //grabbing the file
});</pre>

<h3 id="durationchange">durationchange</h3>

<p>If you just want to know as soon as the duration of your media is established, this is the event for you. This can be useful because the initial value for duration is <code>NaN</code> (Not a Number), which you probably don't want to display to your users.</p>

<pre class="brush: js notranslate">myAudio.addEventListener("durationchange", function() {
  //you can display the duration now
});</pre>

<h3 id="loadedmetadata">loadedmetadata</h3>

<p>Metadata can consist of more than just duration — if you want to wait for all the metadata to download before doing something, you can detect the <code>loadedmetadata</code> event.</p>

<pre class="brush: js notranslate">myAudio.addEventListener("loadedmetadata", function() {
  //you can display the duration now
});</pre>

<h3 id="loadeddata">loadeddata</h3>

<p>The <code>loadeddata</code> event is fired when the first bit of media arrives. The playhead is in position but not quite ready to play.</p>

<pre class="brush: js notranslate">myAudio.addEventListener("loadeddata", function() {
  //you could display the playhead now
});</pre>

<h3 id="progress">progress</h3>

<p>The <code>progress</code> event indicates that the download of media is still in progress. It is good practice to display some kind of 'loader' at this point.</p>

<pre class="brush: js notranslate">myAudio.addEventListener("progress", function() {
  // you could let the user know the media is downloading
});</pre>

<h3 id="canplay">canplay</h3>

<p><code>canplay</code> is a useful event to detect should you want to determine whether the media is ready to play. You could, for example, disable custom controls until this event occurs.</p>

<pre class="brush: js notranslate">myAudio.addEventListener("canplay", function() {
  //audio is ready to play
});</pre>

<h3 id="canplaythrough">canplaythrough</h3>

<p><code>canplaythrough</code> is similar to <code>canplay</code> but it lets you know that the media is ready to be played all the way through (that is to say that the file has completely downloaded, or it is estimated that it will download in time so that buffering stops do not occur).</p>

<pre class="brush: js notranslate">myAudio.addEventListener("canplaythrough", function() {
  //audio is ready to play all the way through
});</pre>

<h3 id="Media_loading_event_order">Media loading event order</h3>

<p>To recap, the order of the media loading events are:</p>

<p><code>loadstart</code> &gt; <code>durationchange</code> &gt; <code>loadedmetadata</code> &gt; <code>loadeddata</code> &gt; <code>progress</code> &gt; <code>canplay</code> &gt; <code>canplaythrough</code></p>

<h3 id="Loading_interruption_events">Loading interruption events</h3>

<p>We also have a few events available that will fire when there is some kind of interruption to the media loading process.</p>

<dl>
 <dt>suspend</dt>
 <dd>Media data is no longer being fetched even though the file has not been entirely downloaded.</dd>
 <dt>abort</dt>
 <dd>Media data download has been aborted but not due to an error.</dd>
 <dt>error</dt>
 <dd>An error is encountered while media data is being download.</dd>
 <dt>emptied</dt>
 <dd>The media buffer has been emptied, possibly due to an error or because the load() method was invoked to reload it.</dd>
 <dt>stalled</dt>
 <dd>Media data is unexpectedly no longer available.</dd>
</dl>

<h2 id="Media_Playing_Events">Media Playing Events</h2>

<p>We also have another set of events that are useful for reacting to the state of the media playback.</p>

<h3 id="timeupdate">timeupdate</h3>

<p>The <code>timeupdate</code> event is triggered every time the <code>currentTime</code> property changes. In practice, this occurs every 250 milliseconds. This event can be used to trigger the displaying of playback progress.</p>

<pre class="notranslate">myAudio.addEventListener("timeupdate", function() {
  //update something related to playback progress
});</pre>

<h3 id="playing">playing</h3>

<p>The <code>playing</code> event is initiated when playback is ready to start after having being paused due to lack of media data.</p>

<h3 id="waiting">waiting</h3>

<p>The <code>waiting</code> event is triggered when playback has stopped due to lack of media data, although it is expected to resume once data becomes available.</p>

<h3 id="play_2">play</h3>

<p>The <code>play</code> event is initiated after the <code>play()</code> method is returned or when the <code>autoplay</code> attribute has caused playback to begin. This is when the state of the media switches from paused to playing.</p>

<h3 id="pause_2">pause</h3>

<p>The <code>pause</code> event is triggered after the <code>pause()</code> method is returned. This is when the states switch from playing to paused.</p>

<h3 id="ended">ended</h3>

<p>The <code>ended</code> event is initiated when the end of the media is reached.</p>

<pre class="brush: js notranslate">myAudio.addEventListener("ended", function() {
  //do something once audio track has finished playing
});</pre>

<h3 id="volumechange">volumechange</h3>

<p>The <code>volumechange</code> event signifies that the volume has changed; that includes being muted.</p>

<h2 id="An_Audio_Player_with_Feedback">An Audio Player with Feedback</h2>

<p>Consider this snippet of HTML:</p>

<pre class="brush: html notranslate">&lt;audio id="my-audio"&gt;
  &lt;source src="http://jPlayer.org/audio/mp3/Miaow-07-Bubble.mp3" type="audio/mpeg"&gt;
  &lt;source src="http://jPlayer.org/audio/ogg/Miaow-07-Bubble.ogg" type="audio/ogg"&gt;
  &lt;!-- place fallback here as &lt;audio&gt; supporting browsers will ignore it --&gt;
  &lt;a href="audiofile.mp3"&gt;audiofile.mp3&lt;/a&gt;
&lt;/audio&gt;

&lt;div id="controls"&gt;
  &lt;span id="loading"&gt;loading&lt;/span&gt;
  &lt;button id="play" style="display:none"&gt;play&lt;/button&gt;
  &lt;button id="pause" style="display:none" &gt;pause&lt;/button&gt;
&lt;/div&gt;
&lt;div id="progress"&gt;
  &lt;div id="bar"&gt;&lt;/div&gt;
&lt;/div&gt;</pre>

<p>Styled like so:</p>

<pre class="brush: css notranslate">#controls {
   width: 80px;
   float: left;
}

#progress {
   margin-left: 80px;
   border: 1px solid black;
}

#bar {
   height: 20px;
   background-color: green;
   width: 0;
}</pre>

<p>Now let's wire this thing up with JavaScript:</p>

<pre class="brush: js notranslate">window.onload = function(){

   var myAudio = document.getElementById('my-audio');
   var play = document.getElementById('play');
   var pause = document.getElementById('pause');
   var loading = document.getElementById('loading');
   var bar = document.getElementById('bar');

   function displayControls() {
      loading.style.display = "none";
      play.style.display = "block";
   }

   // check that the media is ready before displaying the controls
   if (myAudio.paused) {
      displayControls();
   } else {
      // not ready yet - wait for canplay event
      myAudio.addEventListener('canplay', function() {
         displayControls();
      });
   }

   play.addEventListener('click', function() {
      myAudio.play();
      play.style.display = "none";
      pause.style.display = "block";
   });

   pause.addEventListener('click', function() {
      myAudio.pause();
      pause.style.display = "none";
      play.style.display = "block";
   });

   // display progress

   myAudio.addEventListener('timeupdate', function() {
      //sets the percentage
      bar.style.width = parseInt(((myAudio.currentTime / myAudio.duration) * 100), 10) + "%";
   });

}</pre>

<p>You should end up with something like this:</p>

<p><img alt="A basic audio player with play/pause button and seek bar" src="https://mdn.mozillademos.org/files/7489/simpleplayer.png" style="float: left; height: 55px; width: 422px;"></p>

<p><br>
   </p>

<h3 id="Seeking_using_the_seek_bar">Seeking using the seek bar</h3>

<p>This is a good start, but it would be nice to be able to navigate the audio using the progress bar. Fortunately this isn't too difficult to implement.</p>

<p>First of all, we apply a quick update to the progress bar CSS to display the hand pointer on hover:</p>

<pre class="brush: css notranslate">#progress {
   margin-left: 80px;
   border: 1px solid black;
   cursor: pointer;
}</pre>

<p>Then we add the code that detects the click and moves the 'playhead' to the correct position:</p>

<pre class="brush: js notranslate">var progress = document.getElementById('progress');

progress.addEventListener('click', function(e) {

  // calculate the normalized position clicked
  var clickPosition = (e.pageX  - this.offsetLeft) / this.offsetWidth;
  var clickTime = clickPosition * myAudio.duration;

  // move the playhead to the correct position
  myAudio.currentTime = clickTime;
});</pre>

<h3 id="Buffering">Buffering</h3>

<p>Ok, we're getting there, but there is another piece of useful information we can display: the amount of audio has been buffered or downloaded in advance.<br>
 <br>
 There are a couple of properties we haven't looked at yet, <code>buffered</code> and <code>seekable</code>.</p>

<h4 id="buffered">buffered</h4>

<p>This property lets us know which parts of the audio has been buffered (downloaded in advance). It returns something called a <code>TimeRanges</code> object.</p>

<pre class="brush: js notranslate">myBufferedTimeRanges = myAudio.buffered;</pre>

<h4 id="seekable">seekable</h4>

<p>The seekable property informs you of whether you can jump directly to that part of the media without further buffering.</p>

<pre class="brush: js notranslate">mySeekableTimeRanges = myAudio.seekable;</pre>

<h4 id="Buffering_events">Buffering events</h4>

<p>There are also a couple of events related to buffering:</p>

<dl>
 <dt><code>seeking</code></dt>
 <dd>The <code>seeking</code> event is fired when media is being sought.</dd>
 <dt><code>seeked</code></dt>
 <dd><code>seeked</code> occurs when the <code>seeking</code> attribute changes to <code>false</code>.</dd>
</dl>

<div class="note">
<p><strong>Note</strong>: you can read more on <a href="/en-US/Apps/Build/Manipulating_media/buffering_seeking_time_ranges">Buffering, Seeking and Time Ranges</a> elsewhere.</p>
</div>

<h2 id="Browser_support">Browser support</h2>

<p>The following tables list basic audio support across desktop and mobile browsers, and what audio codecs are supported.</p>

<h3 id="Desktop">Desktop</h3>

<table>
 <thead>
  <tr>
   <th>Desktop Browser</th>
   <th>Version</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>Chrome</td>
   <td>4+</td>
  </tr>
  <tr>
   <td>Firefox</td>
   <td>3.5+</td>
  </tr>
  <tr>
   <td>Internet Explorer</td>
   <td>9+</td>
  </tr>
  <tr>
   <td>Opera</td>
   <td>10.5+</td>
  </tr>
  <tr>
   <td>Safari</td>
   <td>4+</td>
  </tr>
 </tbody>
</table>

<h3 id="Mobile">Mobile</h3>

<table>
 <thead>
  <tr>
   <th>Mobile Browser</th>
   <th>Version</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>Chrome (Android)</td>
   <td>32+</td>
  </tr>
  <tr>
   <td>Firefox (Android)</td>
   <td>26+</td>
  </tr>
  <tr>
   <td>IE Mobile</td>
   <td>10+</td>
  </tr>
  <tr>
   <td>Opera Mobile</td>
   <td>11+</td>
  </tr>
  <tr>
   <td>Safari (iOS)</td>
   <td>4+</td>
  </tr>
  <tr>
   <td>Android Browser</td>
   <td>2.3+</td>
  </tr>
  <tr>
   <td>Blackberry</td>
   <td>7+</td>
  </tr>
 </tbody>
</table>

<h2 id="Audio_Codec_Support">Audio Codec Support</h2>

<table>
 <thead>
  <tr>
   <th>Browser</th>
   <th>Ogg</th>
   <th>MP3</th>
   <th>AAC</th>
   <th>PCM</th>
   <th>Opus</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>Firefox 3.5+</td>
   <td>✓</td>
   <td>✓ *26+</td>
   <td></td>
   <td>✓</td>
   <td>✓ *14+</td>
  </tr>
  <tr>
   <td>Safari 5+</td>
   <td></td>
   <td>✓</td>
   <td>✓</td>
   <td></td>
   <td></td>
  </tr>
  <tr>
   <td>Chrome 6+</td>
   <td>✓</td>
   <td>✓</td>
   <td>✓</td>
   <td>✓ *9+</td>
   <td></td>
  </tr>
  <tr>
   <td>Opera 10.5+</td>
   <td>✓</td>
   <td></td>
   <td></td>
   <td></td>
   <td></td>
  </tr>
  <tr>
   <td>Internet Explorer 9+</td>
   <td></td>
   <td>✓</td>
   <td>✓</td>
   <td></td>
   <td></td>
  </tr>
  <tr>
   <td>Firefox Mobile</td>
   <td>✓</td>
   <td>✓</td>
   <td>✓</td>
   <td>✓</td>
   <td>✓</td>
  </tr>
  <tr>
   <td>Safari iOS3+</td>
   <td></td>
   <td>✓</td>
   <td>✓</td>
   <td>✓ *4.2+</td>
   <td></td>
  </tr>
  <tr>
   <td>Chrome Mobile</td>
   <td>✓</td>
   <td>✓</td>
   <td>✓</td>
   <td>✓</td>
   <td></td>
  </tr>
  <tr>
   <td>Opera Mobile</td>
   <td>✓</td>
   <td>✓</td>
   <td>✓</td>
   <td>✓</td>
   <td></td>
  </tr>
  <tr>
   <td>Internet Explorer Mobile</td>
   <td>✓</td>
   <td>✓</td>
   <td>✓</td>
   <td>✓</td>
   <td></td>
  </tr>
  <tr>
   <td>Android 2.3+</td>
   <td>✓</td>
   <td>✓</td>
   <td>✓</td>
   <td>✓</td>
   <td></td>
  </tr>
 </tbody>
</table>

<div class="note">
<p><strong>Note</strong>: We are at the stage where nearly all browsers support MP3 — for more details visit this page on <a href="/en-US/docs/HTML/Supported_media_formats#Browser_compatibility">media format browser compatibility</a>.</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/Apps/Build/Manipulating_media/buffering_seeking_time_ranges">Buffering, Seeking and Time Ranges</a></li>
 <li><a href="/en-US/docs/Web/Guide/Events/Media_events">Media events</a></li>
 <li><a href="/en-US/docs/Web/Guide/HTML/Using_HTML5_audio_and_video">Using HTML5 audio and video</a></li>
 <li><a href="/en-US/Apps/Build/Manipulating_media/cross_browser_video_player">Creating a cross-browser video player</a></li>
 <li><a class="external" href="http://jPlayer.org">jPlayer</a>: An open source audio and video library for jQuery and Zepto.</li>
 <li><a href="http://jplayer.org/HTML5.Media.Event.Inspector">Media Event Inspector</a><br>
   </li>
</ul>
